# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import DataInfo
import HRFData

from wxPython.wx import *
from Commonwx import *
from Common import *

formations = [
    "343",
    "352",
    "433",
    "451",
    "532",
    "541"]

class FormationDialog(wxDialog):

    def __init__(self, parent, htdata):

        pos = wxDefaultPosition
        size = wxDefaultSize,
        style = wxDEFAULT_DIALOG_STYLE

        wxDialog.__init__(self, parent, -1, _("Formations"), pos, wxSize(500, 400), style, "Uppstllningar")

        sizer = wxBoxSizer(wxVERTICAL)

        # Ok / Cancel buttons

        if htdata != None:
            fgs=wxFlexGridSizer(cols=2, vgap=5, hgap=10)
            formationtext=wxStaticText(self,-1,_("Formation"))
            SetTextBold(formationtext)
            fgs.Add(formationtext)
            exptext=wxStaticText(self,-1,_("Experience"))
            SetTextBold(exptext)
            fgs.Add(exptext)

            for text in formations:
                fgs.Add(wxStaticText(self,-1,text[0] + "-" + text[1] + "-" + text[2]))
                fgs.Add(wxStaticText(self,-1,getattr(htdata.get_section("team",True),"exper"+text)))


            sizer.Add(fgs, 0, wxALIGN_CENTER | wxALL, 10)

        button = wxButton(self, wxID_OK, _("Ok"))
        button.SetDefault()

        sizer.Add(button, 0, wxALIGN_RIGHT | wxALL, 10)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)
