# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os.path

from wxPython.wx import *

wxInitAllImageHandlers()

class ImageStorage:
    def __init__(self, search_path):
        self.search_path = [os.path.abspath(p) for p in search_path.split(':')]
        self.images = {}

    def get_bitmap_from_file(self, img_path):
        if img_path == "":
            return wxNullBitmap

        img_path = os.path.normpath(img_path)
        if self.images.has_key(img_path):
            return self.images[img_path]

        bmp = wxNullBitmap
        if os.path.isabs(img_path):
            sp = [""]
        else:
            sp = self.search_path

        for p in sp:
            file = os.path.join(p, img_path)
            #print file
            if os.path.exists(file):
                img = wxImage(file, wxBITMAP_TYPE_ANY)
                if img.Ok():
                    bmp = img.ConvertToBitmap()
                    break
        self.images[img_path] = bmp
        return bmp

datapath = "Data:/usr/share/Mattricks:/usr/local/share/Mattricks:" + \
               os.path.abspath(os.path.dirname(sys.argv[0])) + \
               "/Data"
Images = ImageStorage(datapath)

def create_star_image(rating):
    star = Images.get_bitmap_from_file("star.png")
    star_half = Images.get_bitmap_from_file("star_half.png")
    (nstars, nhalfstars) = divmod(rating, 2)

    if rating == 1:
        return star_half
    elif rating == 2:
        return star

    ws = star.GetWidth()
    wh = star_half.GetWidth()
    wr = ws*nstars + wh*nhalfstars
    hs = star.GetHeight()
    hh = star_half.GetHeight()
    hr = max(hs,hh)

    bmp = wxEmptyBitmap(wr,hh)

    image = wxMemoryDC()
    image.SelectObject(bmp)

    image.SetBrush(wxBrush("MAGENTA"))
    image.Clear()

    cw = 0
    for i in range(nstars):
        image.DrawBitmap(star, cw, 0, False)
        cw += ws
    for i in range(nhalfstars):
        image.DrawBitmap(star_half, cw, 0, False)
        cw += wh

    del image

    bmp.SetMaskColour("MAGENTA")

    return bmp
