# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import DataInfo
import HRFData
import random

from wxPython.wx import *
from Common import *
from Commonwx import *

abilities=[
        ['ald', 16, 1],
        ['gentleness', -1, 1],
        ['mkt', 0, 100000],
        ['Aggressiveness', -1, 1],
        ['sal', 4000, 1000],
        ['honesty', -1, 1],
        ['speciality', -1, 1],
        ['led', 0, 1],
        None,
        None,
        ['uth', 0, 1],
        ['mlv', 0, 1],
        ['spe', 0, 1],
        ['fra', 0, 1],
        ['ytt', 0, 1],
        ['bac', 0, 1],
        ['mal', 0, 1],
        ['fas', 0, 1]]

class JuniorSpy(wxDialog):

    ID_BUTTON_BASE=400
    ID_SHOW_BUTTON=450
    ID_RANDOM_BUTTON=451
    def __init__(self, parent, htdata, player_id, style = 1):

        pos = wxDefaultPosition
        size = wxDefaultSize,
        wstyle = wxDEFAULT_DIALOG_STYLE

        wxDialog.__init__(self, parent, -1, htdata.get_player(player_id,True).name, pos, wxSize(500, 400), wstyle, htdata.get_player(player_id,True).name)

        sizer = wxBoxSizer(wxVERTICAL)

        self.style=style
        self.htdata=htdata
        self.player_id=player_id

        nametext=wxStaticText(self,-1,htdata.get_player(player_id,True).name + " (" + str(player_id) + ")")
        SetTextFace(nametext, FACE_BOLD | FACE_BIG)
        sizer.Add(nametext, 0, wxALL,10)

        offset=0
        if htdata != None:
            fgs=wxFlexGridSizer(cols=4, vgap=5, hgap=10)
            for text in abilities:
                if text == None:
                    fgs.Add(15,15)
                    fgs.Add(15,15)
                else:
                    fgs.Add(wxButton(self,JuniorSpy.ID_BUTTON_BASE+offset,DataInfo.known_player_data_info[text[0]][1]),0,wxEXPAND)
                    dispstring="disp"+text[0]
                    setattr(self,dispstring,wxStaticText(self,-1,"                                 "))
                    fgs.Add(getattr(self,dispstring),0,wxALIGN_CENTER_VERTICAL)
                    setattr(self,"val"+text[0],text[1])
                    EVT_BUTTON(self, JuniorSpy.ID_BUTTON_BASE+offset, self.OnButton)
                offset+=1

            sizer.Add(fgs, 0, wxALIGN_CENTER | wxALL, 10)

        line = wxStaticLine(self, -1, style = wxLI_HORIZONTAL)
        sizer.Add(line, 0, wxEXPAND | wxALIGN_CENTRE, 5)

        # Ok / Cancel buttons
        hsizer = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("Ok"))
        button.SetDefault()
        showbutton = wxButton(self, JuniorSpy.ID_SHOW_BUTTON, _("Show everything"))
        randombutton = wxButton(self, JuniorSpy.ID_RANDOM_BUTTON, _("Random"))

        hsizer.Add(showbutton, 0, wxALL | wxALIGN_LEFT, 5)
        hsizer.Add(randombutton, 0, wxALL | wxALIGN_LEFT, 5)
        hsizer.Add(1,1,1,wxEXPAND)
        hsizer.Add(button, 0, wxALIGN_RIGHT | wxALL, 5)

        sizer.AddSizer(hsizer, 0, wxALL | wxALIGN_RIGHT | wxEXPAND)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)

        EVT_BUTTON(self, JuniorSpy.ID_SHOW_BUTTON, self.OnShowAll)
        EVT_BUTTON(self, JuniorSpy.ID_RANDOM_BUTTON, self.OnShowRandom)

    def OnButton(self, event):
        button_id=event.GetId()
        id=button_id-JuniorSpy.ID_BUTTON_BASE
        self.ShowValue(id)

    def OnShowRandom(self,event):
        ablist=[]
        offset=0
        for ability in abilities:
            if ability != None:
                button=self.FindWindowById(JuniorSpy.ID_BUTTON_BASE+offset)
                if button.IsEnabled():
                    ablist.append(offset)
            offset+=1
        if len(ablist) > 0:
            id=random.randint(1,len(ablist))-1
            self.ShowValue(ablist[id])

    def OnShowAll(self, event):
        offset=0
        for ability in abilities:
            if ability != None:
                text=getattr(self, "disp"+ability[0])
                func=DataInfo.known_player_data_info[ability[0]][3]
                pval=getattr(self.htdata.get_player(self.player_id),ability[0])
                text.SetLabel(func(pval))
                SetTextBold(text)
                button=self.FindWindowById(JuniorSpy.ID_BUTTON_BASE+offset)
                button.Disable()
            offset+=1
        self.Layout()

    def ShowValue(self,id):
        ability=abilities[id]
        text=getattr(self, "disp"+ability[0])
        val=getattr(self, "val"+ability[0])
        inc=ability[2]
        func=DataInfo.known_player_data_info[ability[0]][3]

        valtmp = val+inc
        pval=getattr(self.htdata.get_player(self.player_id),ability[0])
        if valtmp >= pval:
            valtmp = pval

        if self.style == 0:
            valtmp = pval

        text.SetLabel(func(valtmp))
        setattr(self,"val"+ability[0],valtmp)

        if valtmp == pval:
            SetTextBold(text)
            button=self.FindWindowById(id+JuniorSpy.ID_BUTTON_BASE)
            button.Disable()
        self.Layout()    

class JuniorSpySelect(wxDialog):

    ID_BUTTON_BASE=400

    def __init__(self, parent, htdata):

        pos = wxDefaultPosition
        size = wxDefaultSize,
        style = wxDEFAULT_DIALOG_STYLE

        wxDialog.__init__(self, parent, -1, _("Junior Spy"), pos, wxSize(500, 400), style, "Junior Spy")

        sizer = wxBoxSizer(wxVERTICAL)

        sizer.Add(wxStaticText(self, -1, _("Player")),0,wxALL, 10)
        self.listbox = wxListBox(self, -1, style=wxLB_SINGLE)
        sizer.Add(self.listbox,0,wxALL,5)

        self.htdata=htdata
        self.pids=htdata.get_pids()
        self.pids.sort()

        for pid in self.pids:
            self.listbox.Append(htdata.get_player(pid, True).name)


        self.listbox.SetSelection(self.listbox.GetCount()-1)

        sizer.Add(wxStaticText(self, -1, _("Display style")), 0, wxALL, 10)

        styles = [_("Direct"), _("Step")]
        self.style = wxChoice(self, -1, choices=styles)
        self.style.SetSelection(1)
        sizer.Add(self.style, 0, wxALL, 5)

        # Ok / Cancel buttons
        button = wxButton(self, wxID_OK, _("Ok"))
        button.SetDefault()

        sizer.Add(button, 0, wxALIGN_RIGHT | wxALL, 10)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)


    def OnOK(self, event):
        id=self.listbox.GetSelection()
        style=self.style.GetSelection()
        dlg=JuniorSpy(self,self.htdata,self.pids[id],style)
        self.EndModal(wxID_OK)
        dlg.ShowModal()
        dlg.Destroy()
